; mklen for Prowess SBasic Interface
; v. 1.01 1996 May 22 09:36:41
; copyright W. Lenerz 1996
; this works with Sbasic & compiled programs only



****************************************************************************
*
* syntax:  MKLEN string$
*	 MKLEN0 string$
* makes true length for the string, MKLEN0 doesn't strip off the chr$(0)
*
*
*****************************************************************************

	section	text
	xdef	mklen
	xdef	mklen0

mklen0	MOVEQ	#1,D7		; future length: +1 for chr$(0)
	BRA.S	common
mklen	MOVEQ	#0,D7		; future length
common	MOVE.W	(A6,A3.L),D0	; type word
	MOVE.L	4(A6,A3.L),A1	; point to value now (this is Sbasic, so no indexing rel to A6 here!)
	ANDI.B	#$F,D0		; get rid of interference
	CMP.B	#1,D0		; is it a string?
	BNE.S	out		; no!
	CMP.W	#$201,D0	; is it array?
	BEQ.S	on_stack	; no->...
	MOVE.L	(A1),A1		; true value pointer if array
on_stack	LEA	 2(A1),A2  ; point after length word
count	TST.B	(A2)+		; now find chr$(0)
	BEQ.S	endstring
	ADDQ.W	#1,D7
	BRA.S	count
endstring MOVE.W	D7,(A1)		; change length of string directly!
	MOVEQ	#0,D0		; and return
	RTS
out	MOVEQ	#-15,D0
	RTS


	end
