/*
	ProWesS, PROGS Windowing System

	test program for listselect type

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	06.05.1997 started
*/

#include <ProWesS.h>

char array[7][20]={ "ProWesS",
					"LINEdesign",
					"DATAdesign",
					"PFlist",
					"fsearch",
					"PROforma fontpack",
					"fontutils" };

Error select(PWObject object, char *item)
{
	PWObject info;
	PWQuery(object,PW_GLOBAL_AUXILIARY,&info);
	return PWChange(info,PW_INFOSTRING_TEXT,item,NULL);
}

void init()
{
	PWObject obj,it1,it2;

	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_TITLE_TEXT, "",
				NULL);
	PWCreate(obj,&it1,PW_TYPE_LISTSELECT,
				PW_LISTSELECT_ADD_ARRAY,7,20,array,
				PW_LISTSELECT_ACTION_SELECT, select,
				PW_LISTSELECT_COMMENT, "program :",
				PW_LISTSELECT_TITLE, "choose",
				NULL);
	PWCreate(obj,&it2,PW_TYPE_INFOSTRING,NULL);
	PWChange(obj,PW_GLOBAL_AUXILIARY,it2,NULL);
	PWActivate(obj);
}
